package net.xuyezo.main;

import java.util.Random;

import org.bukkit.HeightMap;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.data.BlockData;
import org.bukkit.generator.ChunkGenerator;
import org.bukkit.generator.WorldInfo;
import org.bukkit.util.noise.PerlinNoiseGenerator;
import org.jetbrains.annotations.NotNull;

public class Generator extends ChunkGenerator {

	public PerlinNoiseGenerator gen;
	
	public Generator() {
		this.gen = new PerlinNoiseGenerator(69420);
	}
	
	public static int getHash(int x,int z) {
		return (((x * 223) ^ (z * 82395) ^ (x * 9634) ^ (z * 23958)) & 0x2FF3);
	}
	
	@Override
	public void generateNoise(WorldInfo worldInfo, Random random, int chunkX, int chunkZ,
			ChunkGenerator.ChunkData chunkData) {
		for (int x = 0; x < 16; x++) {
			for (int z = 0; z < 16; z++) { 
				for (int y = chunkData.getMinHeight(); y < chunkData.getMaxHeight(); y++) {
					chunkData.setBlock(x, y, z, Material.AIR);
				}
			}
		}
		
		for (int x = 0; x < 16; x++) {
			for (int z = 0; z < 16; z++) {
				for (int y = chunkData.getMinHeight(); y < chunkData.getMaxHeight(); y++) {

					int x2 = chunkX * 16 + x;
					int z2 = chunkZ * 16 + z;
					
					double fac = (y - chunkData.getMinHeight()) / (1.0 * chunkData.getMaxHeight());
					fac = 1.0 - fac;
					
					if (this.gen.noise(x2 * 0.01,y* 0.01,z2* 0.01, 5, 1.5, 0.5) * fac < 0.4) continue;
					
					chunkData.setBlock(x, y, z, Material.STONE);
				}
			}
		}
	}

	@Override
	public boolean canSpawn(World world, int x, int z) {
		return true;
	}

	@Override
	public int getBaseHeight(@NotNull WorldInfo worldInfo, @NotNull Random random, int x, int z,
			@NotNull HeightMap heightMap) {
		int h = Generator.getHash(x,z);
		h = Math.max(h, worldInfo.getMinHeight());
		return Math.min(h,worldInfo.getMaxHeight());
	}

	@Override
	public boolean shouldGenerateCaves() {
		return false;
	}

	@Override
	public boolean shouldGenerateDecorations() {
		return false;
	}

	@Override
	public boolean shouldGenerateMobs() {
		return false;
	}

	@Override
	public boolean shouldGenerateNoise() {
		return false;
	}

	@Override
	public boolean shouldGenerateStructures() {
		return false;
	}

	@Override
	public boolean shouldGenerateSurface() {
		return false;
	}
}
