package net.xuyezo.main;

import java.util.Random;

import org.bukkit.Bukkit;
import org.bukkit.GameMode;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockExplodeEvent;
import org.bukkit.event.entity.EntityExplodeEvent;
import org.bukkit.event.entity.EntityPortalEvent;
import org.bukkit.event.player.PlayerPortalEvent;
import org.bukkit.inventory.ItemStack;

public class Handler implements Listener {

	@EventHandler
	private void onPortalEvent(PlayerPortalEvent e) {
		Random random = new Random();
		Location t = e.getFrom();
		t.multiply(-1);
		t.add(0,256,0);
		e.setTo(t);
	}
	
	@EventHandler
	private void onBlockExplode(BlockExplodeEvent e) {
		e.setCancelled(true);
		for (Block b : e.blockList()) {
			Location loc = b.getLocation();
			
			if (b.getType() == Material.STONE) {
				b.setType(Material.LAVA);
			} else if (b.getType() == Material.COBBLESTONE || b.getType() == Material.GRAVEL) {
				Material[] items = {
						Material.ICE,
						Material.ICE,
						Material.ICE,
						Material.ICE,
						Material.ICE,
						Material.ICE,
						Material.ICE,
						Material.ICE,
						Material.COAL_ORE,
						Material.COAL_ORE,
						Material.COAL_ORE,
						Material.COAL_ORE,
						Material.COAL_ORE,
						Material.COAL_ORE,
						Material.COAL_ORE,
						Material.COAL_ORE,
						Material.COPPER_ORE,
						Material.COPPER_ORE,
						Material.COPPER_ORE,
						Material.COPPER_ORE,
						Material.IRON_ORE,
						Material.IRON_ORE,
						Material.GOLD_ORE,
						Material.GOLD_ORE,
						Material.DIAMOND_ORE
				};

				b.setType(Material.AIR);
				if (new Random().nextInt(4) != 0) continue;
				b.getWorld().dropItem(loc, new ItemStack(items[new Random().nextInt(items.length)]));
			}
		}
	}
	
	@EventHandler
	private void onBlockBreak(BlockBreakEvent e) {
		Block b = e.getBlock();
		Player p = e.getPlayer();
		if (p.getGameMode() != GameMode.SURVIVAL)
			return;

		ItemStack i = p.getInventory().getItem(p.getInventory().getHeldItemSlot());
		
		if (i != null && !i.isEmpty() && b.isPreferredTool(i))
			return;

		Location loc = b.getLocation();
		loc.add(0,1.5,0);
		
		//todo: clean
		if (b.getType() == Material.STONE) {
			e.setCancelled(true);
			b.setType(Material.COBBLESTONE);
		} else if (b.getType() == Material.COBBLESTONE) {
			e.setCancelled(true);
			b.setType(Material.AIR);
			
			Material[] items = {
					Material.GRAVEL,
					Material.GRAVEL,
					Material.SAND,
					Material.RED_SAND,
					Material.CLAY_BALL,
					Material.CLAY_BALL
			};
			
			for (int j = 0; j < 3; j++) {
				Material r = items[new Random().nextInt(items.length)];
				b.getWorld().dropItem(loc, new ItemStack(r));
			}
		}
	}
}
