package net.xuyezo.main;

import net.kyori.adventure.text.Component;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.NamespacedKey;
import org.bukkit.Server;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.generator.BiomeProvider;
import org.bukkit.generator.ChunkGenerator;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.RecipeChoice;
import org.bukkit.inventory.ShapedRecipe;
import org.bukkit.inventory.meta.Damageable;
import org.bukkit.plugin.java.JavaPlugin;

public class Main extends JavaPlugin {

	@Override
	public void onEnable() {
		Bukkit.getPluginManager().registerEvents(new Handler(), this);

        Server server = getServer();
        
        NamespacedKey key = new NamespacedKey(this, "FlintAxe");
        ItemStack item = new ItemStack(Material.STONE_AXE);
        Damageable meta = (Damageable) item.getItemMeta();
        meta.setMaxDamage(80);
        meta.displayName(Component.text("Flint Axe"));
        item.setItemMeta(meta);
        ShapedRecipe recipe = new ShapedRecipe(key, item);
        recipe.shape("A  ", "B  ", "   ");
        recipe.setIngredient('A', Material.FLINT);
        recipe.setIngredient('B', Material.STICK);
        server.addRecipe(recipe);
        
        key = new NamespacedKey(this, "FlintPickaxe");
        item = new ItemStack(Material.STONE_PICKAXE);
        meta = (Damageable) item.getItemMeta();
        meta.setMaxDamage(100);
        meta.displayName(Component.text("Flint Pickaxe"));
        item.setItemMeta(meta);
        recipe = new ShapedRecipe(key, item);
        recipe.shape("AA ", "B  ", "   ");
        recipe.setIngredient('A', Material.FLINT);
        recipe.setIngredient('B', Material.STICK);
        server.addRecipe(recipe);

        key = new NamespacedKey(this, "BoneDirt");
        item = new ItemStack(Material.GRASS_BLOCK,1);
        recipe = new ShapedRecipe(key, item);
        recipe.shape("AAA", "ABA", "ACA");
        recipe.setIngredient('A', Material.GRAVEL);
        recipe.setIngredient('B', Material.BONE_MEAL);
        recipe.setIngredient('C', new RecipeChoice.MaterialChoice(Material.COAL,Material.CHARCOAL));
        server.addRecipe(recipe);
        
        key = new NamespacedKey(this, "StoneStick");
        item = new ItemStack(Material.STICK,4);
        recipe = new ShapedRecipe(key, item);
        recipe.shape("A  ", "A  ", "   ");
        recipe.setIngredient('A', Material.COBBLESTONE);
        server.addRecipe(recipe);
        
        key = new NamespacedKey(this, "GrassSapling");
        item = new ItemStack(Material.OAK_SAPLING);
        recipe = new ShapedRecipe(key, item);
        recipe.shape("AAA", "ABA", "AAA");
        recipe.setIngredient('A', Material.BONE_MEAL);
        recipe.setIngredient('B', Material.DIRT);
        server.addRecipe(recipe);


        key = new NamespacedKey(this, "CoarseishDirt");
        item = new ItemStack(Material.COARSE_DIRT,2);
        recipe = new ShapedRecipe(key, item);
        recipe.shape("AB ", "   ", "   ");
        recipe.setIngredient('A', Material.GRAVEL);
        recipe.setIngredient('B', Material.DIRT);
        server.addRecipe(recipe);

        
        key = new NamespacedKey(this, "StoneTable");
        item = new ItemStack(Material.CRAFTING_TABLE);
        recipe = new ShapedRecipe(key, item);
        recipe.shape("AA ", "AA ", "   ");
        recipe.setIngredient('A', Material.COBBLESTONE);
        server.addRecipe(recipe);

        key = new NamespacedKey(this, "CobbledStone");
        item = new ItemStack(Material.COBBLESTONE);
        recipe = new ShapedRecipe(key, item);
        recipe.shape("AA ", "AA ", "   ");
        recipe.setIngredient('A', Material.GRAVEL);
        server.addRecipe(recipe);
	}

	@Override
	public BiomeProvider getDefaultBiomeProvider(String worldName, String id) {
		return new Biomer();
	}

	@Override
	public ChunkGenerator getDefaultWorldGenerator(String worldName, String id) {
		return new Generator();
	}
}